
// 这句话的定义影响了整个js文件注入之后找不到call方法，需要改成这样
function initAndroid() {
  var isAndroid = navigator.userAgent.indexOf('Android') > -1 || navigator.userAgent.indexOf('Adr') > -1;
  if (isAndroid && !window.PAJSBridge && window.Android.postMessage) {
    window.PACallBackList = {};

    window.PAJSBridge = {
      call: call
    };
    // 这里的定义也会影响js注入的成功与否，需要改成这样
    window.Callback = function(identifier, resultStatus, resultData) {
      var callBackDict = window.PACallBackList[identifier];
      var isFinished;
      if (callBackDict) {
        isFinished = true;
        if (resultStatus === 'success') {
          callBackDict.success(resultData);
        }
        if (resultStatus === 'fail') {
          callBackDict.fail(resultData);
        }
        if (resultStatus === 'progress') {
          isFinished = false;
          callBackDict.progress(resultData);
        }

        if (isFinished) {
          window.PACallBackList[identifier] = null;
          delete window.PACallBackList[identifier];
        }
      }
    };

    window.JSCallBackMethodManager = {
      removeAllCallBacks: function(data) {
        window.PACallBackList = {};
      }
    };
  }
}
function call(bridgeObjc) {
  var dataString = encodeURIComponent(JSON.stringify(bridgeObjc.data));
  var timestamp = new Date().getTime();
  var identifier = hashCode(bridgeObjc.target + bridgeObjc.action + dataString + timestamp);
  window.PACallBackList[identifier] = bridgeObjc.callback;
  window.Android.postMessage(JSON.stringify({ targetName: bridgeObjc.target,
    actionName: bridgeObjc.action,
    data: bridgeObjc.data,
    identifier: identifier }));
}
function hashCode(str) {
  var hash = 0;
  if (str.length === 0) return hash;
  for (var index = 0; index < str.length; index++) {
    var charactor = str.charCodeAt(index);
    hash = ((hash << 5) - hash) + charactor;
    hash = hash & hash;
  }
  return hash;
}

initAndroid();